#ifndef BBCmd_LOOP_H
#define BBCmd_LOOP_H

/**
 * The public header file of BBCmdLoopCommand
 *
 * `Loop' command is used to execute a command many times.
 */

#include "BBCmd.h"


/**
 * Return a new `Loop' command (or NULL for failure).
 *
 * The caller must pass a valid `command'.
 *
 * After passing `command', it will be owned by a new loop command.
 * So the caller must not delete it.
 * The command will be deleted when its owner command is deleted.
 */
BBCmdCommand* BBCmdLoopCommand_FromIntAndCommand(int, BBCmdCommand* command);


#endif
