/* Implementation of `test' command */

#include <assert.h>
#include <stdlib.h>
#include <string.h>

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#include "Test_p.h"




static const char*
_BBCmdTestCommand_initialize( BBCmdCommand* _self,
                              int ac, const char* const* av,
                              const BBCmdCompiler* compiler )
{
	BBCmdTestCommand* self;

	assert(_self->cmd_descriptor == BBCmdTestCommandDescriptor);
	self = (BBCmdTestCommand*)_self;

	self->te_text = NULL;

	if (ac - 1 != 1) return "Incorrect number of arguments";

	self->te_text = strdup(av[1]);
	if (self->te_text == NULL)
		return "Out of memory (_BBCmdTestCommand_initialize)";

	return NULL;
}


static void
_BBCmdTestCommand_del(BBCmdCommand* _self)
{
	BBCmdTestCommand* self;

	assert(_self->cmd_descriptor == BBCmdTestCommandDescriptor);
	self = (BBCmdTestCommand*)_self;

	free(self->te_text);
}


static int
_BBCmdTestCommand_execute(const BBCmdCommand* _self)
{
	BBCmdTestCommand* self;

	assert(_self->cmd_descriptor == BBCmdTestCommandDescriptor);
	self = (BBCmdTestCommand*)_self;

	MessageBox( NULL, self->te_text, "BBCmdTestCommand",
	            MB_OK | MB_ICONINFORMATION | MB_TASKMODAL );

	return BBCmd_RC_TRUE;
}




static const char* _BBCmdTestCommand_alias[] = {
	"Test",
	"TEST",
	"alias_of_test",
	NULL
};

const BBCmdCommandDescriptor _BBCmdTestCommandDescriptor = {
	"test",
	_BBCmdTestCommand_alias,
	"(text) --> true\n"
		"Just display `text' by dialog.\n"
		"This command is just for test while developing early BBCmd.",
	sizeof(BBCmdTestCommand),
	_BBCmdTestCommand_initialize,
	_BBCmdTestCommand_del,
	_BBCmdTestCommand_execute
};




/* __END__ */
