/* malloc() wrappers counting number of calling */

#include <stdlib.h>
#include <string.h>




static int _allocating_count = 0;
int _BBCmd_allocating_count(void) {return _allocating_count;}




void*
_BBCmd_malloc(size_t size)
{
	void* q;

	q = malloc(size);
	if (q != NULL) _allocating_count++;

	return q;
}


void
_BBCmd_free(void* p)
{
	if (p != NULL) _allocating_count--;
	free(p);
}


void*
_BBCmd_realloc(void* p, size_t size)
{
	if (p == NULL) return _BBCmd_malloc(size);
	if (size == 0) {_BBCmd_free(p); return NULL;}

	return realloc(p, size);
}


char*
_BBCmd_strdup(const char* const s)
{
	char* q;

	q = strdup(s);
	if (q != NULL) _allocating_count++;

	return q;
}




/* __END__ */
